class AppView:

    def __init__(self, _model=[]):
        self.model = _model

        # Defined colors
        self.colorBackground = [1.00, 1.00, 1.00]  # white

    def setModel(self, _model):
        self.model = _model

    def getModel(self):
        return self.model

    def isEmpty(self):
        return (self.model is None) or (self.model.isEmpty())

    def getBackgroundColor(self):
        return self.colorBackground

    def getFaces(self):
        return self.model.getFaces()

    def getFacePts(self, _faceID):
        return self.model.getFacePts(_faceID)

    def getFaceNormals(self, _faceID):
        return self.model.getFaceNormals(_faceID)

    def getFaceColors(self, _faceID):
        return self.model.getFaceColors(_faceID)

    def getBoundBox(self):

        if self.model.isEmpty():
            return 0.0, 10.0, 0.0, 10.0, 0.0, 10.0

        pts = self.getFacePts(0)
        x = pts[0].getX()
        y = pts[0].getY()
        z = pts[0].getZ()

        xmin = x
        ymin = y
        zmin = z
        xmax = x
        ymax = y
        zmax = z

        faces = self.model.getFaces()
        for i in range(0, len(faces)):
            pts = self.getFacePts(i)
            for j in range(0, len(pts)):
                x = pts[j].getX()
                y = pts[j].getY()
                z = pts[j].getZ()
                xmin = min(x, xmin)
                xmax = max(x, xmax)
                ymin = min(y, ymin)
                ymax = max(y, ymax)
                zmin = min(z, zmin)
                zmax = max(z, zmax)

        return xmin, xmax, ymin, ymax, zmin, zmax
